Index: binaries/data/mods/public/simulation/ai/qbot/attackMoveToLocation.js
===================================================================
--- binaries/data/mods/public/simulation/ai/qbot/attackMoveToLocation.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/qbot/attackMoveToLocation.js	(Arbeitskopie)
@@ -1,4 +1,6 @@
-function AttackMoveToLocation(gameState, militaryManager, minAttackSize, maxAttackSize, targetFinder){
+function AttackMoveToLocation(gameState, Config, militaryManager, minAttackSize, maxAttackSize, targetFinder){
+	
+	this.Config = Config;	
 	this.minAttackSize = minAttackSize || Config.attack.minAttackSize;
 	this.maxAttackSize = maxAttackSize || Config.attack.maxAttackSize;
 	this.idList=[];
@@ -17,7 +19,7 @@
 	var enemyCount = militaryManager.measureEnemyCount(gameState);
 	
 	// We require our army to be >= this strength
-	var targetStrength = enemyStrength * Config.attack.enemyRatio;
+	var targetStrength = enemyStrength * this.Config.attack.enemyRatio;
 	
 	var availableCount = militaryManager.countAvailableUnits();
 	var availableStrength = militaryManager.measureAvailableStrength();
Index: binaries/data/mods/public/simulation/ai/qbot/worker.js
===================================================================
--- binaries/data/mods/public/simulation/ai/qbot/worker.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/qbot/worker.js	(Arbeitskopie)
@@ -34,7 +34,7 @@
 			
 			this.startApproachingResourceTime = gameState.getTimeElapsed();
 			
-			//Engine.PostCommand({"type": "set-shading-color", "entities": [this.ent.id()], "rgb": [10,0,0]});
+			//Engine.PostCommand(PlayerID, {"type": "set-shading-color", "entities": [this.ent.id()], "rgb": [10,0,0]});
 		}else{
 			// If we haven't reached the resource in 2 minutes twice in a row and none of the resource has been 
 			// gathered then mark it as inaccessible.
@@ -61,7 +61,7 @@
 			this.ent.repair(target);
 		}
 		
-		//Engine.PostCommand({"type": "set-shading-color", "entities": [this.ent.id()], "rgb": [0,10,0]});
+		//Engine.PostCommand(PlayerID, {"type": "set-shading-color", "entities": [this.ent.id()], "rgb": [0,10,0]});
 	}
 	
 	Engine.ProfileStart("Update Gatherer Counts");
@@ -248,4 +248,4 @@
 	}else{
 		return type.generic;
 	}
-};
\ Kein Zeilenumbruch am Ende der Datei
+};
Index: binaries/data/mods/public/simulation/ai/qbot/defence.js
===================================================================
--- binaries/data/mods/public/simulation/ai/qbot/defence.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/qbot/defence.js	(Arbeitskopie)
@@ -1,4 +1,4 @@
-function Defence(){
+function Defence(Config){
 	this.ACQUIRE_DIST = Config.defence.acquireDistance;
 	this.RELEASE_DIST = Config.defence.releaseDistance;
 	
Index: binaries/data/mods/public/simulation/ai/qbot/military.js
===================================================================
--- binaries/data/mods/public/simulation/ai/qbot/military.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/qbot/military.js	(Arbeitskopie)
@@ -6,7 +6,9 @@
  *
  */
 
-var MilitaryAttackManager = function() {
+var MilitaryAttackManager = function(Config) {
+
+	this.Config = Config
 	// these use the structure soldiers[unitId] = true|false to register the units
 	this.attackManagers = [AttackMoveToLocation];
 	this.availableAttacks = [];
@@ -16,7 +18,7 @@
 	this.attackCount = 0;
 	this.lastAttackTime = 0;
 	
-	this.defenceManager = new Defence();
+	this.defenceManager = new Defence(Config);
 };
 
 MilitaryAttackManager.prototype.init = function(gameState) {
@@ -24,22 +26,22 @@
 	
 	// load units and buildings from the config files
 	
-	if (civ in Config.buildings.moderate){
-		this.bModerate = Config.buildings.moderate[civ];
+	if (civ in this.Config.buildings.moderate){
+		this.bModerate = this.Config.buildings.moderate[civ];
 	}else{
-		this.bModerate = Config.buildings.moderate['default'];
+		this.bModerate = this.Config.buildings.moderate['default'];
 	}
 	
-	if (civ in Config.buildings.advanced){
-		this.bAdvanced = Config.buildings.advanced[civ];
+	if (civ in this.Config.buildings.advanced){
+		this.bAdvanced = this.Config.buildings.advanced[civ];
 	}else{
-		this.bAdvanced = Config.buildings.advanced['default'];
+		this.bAdvanced = this.Config.buildings.advanced['default'];
 	}
 	
-	if (civ in Config.buildings.fort){
-		this.bFort = Config.buildings.fort[civ];
+	if (civ in this.Config.buildings.fort){
+		this.bFort = this.Config.buildings.fort[civ];
 	}else{
-		this.bFort = Config.buildings.fort['default'];
+		this.bFort = this.Config.buildings.fort['default'];
 	}
 
 	for (var i in this.bAdvanced){
@@ -54,7 +56,7 @@
 	};
 	// TODO: figure out how to make this generic
 	for (var i in this.attackManagers){
-		this.availableAttacks[i] = new this.attackManagers[i](gameState, this);
+		this.availableAttacks[i] = new this.attackManagers[i](gameState, this.Config, this);
 	}
 	
 	var enemies = gameState.getEnemyEntities();
@@ -435,7 +437,7 @@
 			this.currentAttacks.push(this.availableAttacks[i]);
 			//debug("Attacking!");
 		}
-		this.availableAttacks.splice(i, 1, new this.attackManagers[i](gameState, this));
+		this.availableAttacks.splice(i, 1, new this.attackManagers[i](gameState, this.Config, this));
 	}
 	Engine.ProfileStop();
 	
Index: binaries/data/mods/public/simulation/ai/qbot/entity-extend.js
===================================================================
--- binaries/data/mods/public/simulation/ai/qbot/entity-extend.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/qbot/entity-extend.js	(Arbeitskopie)
@@ -3,12 +3,12 @@
 };
 
 Entity.prototype.garrison = function(target) {
-	Engine.PostCommand({"type": "garrison", "entities": [this.id()], "target": target.id(),"queued": false});
+	Engine.PostCommand(PlayerID, {"type": "garrison", "entities": [this.id()], "target": target.id(),"queued": false});
 	return this;
 };
 
 Entity.prototype.attack = function(unitId)
 {
-	Engine.PostCommand({"type": "attack", "entities": [this.id()], "target": unitId, "queued": false});
+	Engine.PostCommand(PlayerID, {"type": "attack", "entities": [this.id()], "target": unitId, "queued": false});
 	return this;
-};
\ Kein Zeilenumbruch am Ende der Datei
+};
Index: binaries/data/mods/public/simulation/ai/qbot/config.js
===================================================================
--- binaries/data/mods/public/simulation/ai/qbot/config.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/qbot/config.js	(Arbeitskopie)
@@ -1,23 +1,25 @@
-var baseConfig = {
-	"attack" : {
+function Config() {
+	this.debug = false
+
+	this.attack = {
 		"minAttackSize" : 20, // attackMoveToLocation
 		"maxAttackSize" : 60, // attackMoveToLocation
 		"enemyRatio" : 1.5, // attackMoveToLocation
 		"groupSize" : 10 // military
-	},
+	};
 	
 	// defence
-	"defence" : {
+	this.defence = {
 		"acquireDistance" : 220,
 		"releaseDistance" : 250,
 		"groupRadius" : 20,
 		"groupBreakRadius" : 40,
 		"groupMergeRadius" : 10,
 		"defenderRatio" : 2
-	},
+	};
 	
 	// military
-	"buildings" : {
+	this.buildings = {
 		"moderate" : {
 			"default" : [ "structures/{civ}_barracks" ]
 		},
@@ -37,10 +39,10 @@
 			"default" : [ "structures/{civ}_fortress" ],
 			"celt" : [ "structures/{civ}_fortress_b", "structures/{civ}_fortress_g" ]
 		}
-	},
+	};
 
 	// qbot
-	"priorities" : {  // Note these are dynamic, you are only setting the initial values
+	this.priorities = {  // Note these are dynamic, you are only setting the initial values
 		"house" : 500,
 		"citizenSoldier" : 100,
 		"villager" : 100,
@@ -51,13 +53,6 @@
 		"militaryBuilding" : 50,
 		"defenceBuilding" : 17,
 		"civilCentre" : 1000
-	},
-	
-	"debug" : false
+	};
 };
 
-var Config = {
-		"debug": false
-};
-
-Config.__proto__ = baseConfig;
\ Kein Zeilenumbruch am Ende der Datei
Index: binaries/data/mods/public/simulation/ai/qbot/qbot.js
===================================================================
--- binaries/data/mods/public/simulation/ai/qbot/qbot.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/qbot/qbot.js	(Arbeitskopie)
@@ -1,3 +1,4 @@
+var g_debugEnabled = false;
 
 function QBotAI(settings) {
 	BaseAI.call(this, settings);
@@ -4,12 +5,15 @@
 
 	this.turn = 0;
 
+	this.Config = new Config();
+
 	this.modules = {
 			"economy": new EconomyManager(), 
-			"military": new MilitaryAttackManager(), 
+			"military": new MilitaryAttackManager(this.Config), 
 			"housing": new HousingManager()
 	};
 
+
 	// this.queues cannot be modified past initialisation or queue-manager will break
 	this.queues = {
 		house : new Queue(),
@@ -26,7 +30,7 @@
 
 	this.productionQueues = [];
 	
-	this.priorities = Config.priorities;
+	this.priorities = this.Config.priorities;
 	
 	this.queueManager = new QueueManager(this.queues, this.priorities);
 	
@@ -161,7 +165,7 @@
 };
 
 function debug(output){
-	if (Config.debug){
+	if (g_debugEnabled){
 		if (typeof output === "string"){
 			warn(output);
 		}else{
Index: binaries/data/mods/public/simulation/ai/qbot/economy.js
===================================================================
--- binaries/data/mods/public/simulation/ai/qbot/economy.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/qbot/economy.js	(Arbeitskopie)
@@ -357,17 +357,17 @@
 			// Make resources glow wildly 
 			if (resource == "food"){
 				ent.getMetadata("nearby-resources-" + resource).forEach(function(ent){
-					Engine.PostCommand({"type": "set-shading-color", "entities": [ent.id()], "rgb": [10,0,0]});
+					Engine.PostCommand(PlayerID, {"type": "set-shading-color", "entities": [ent.id()], "rgb": [10,0,0]});
 				});
 			}
 			if (resource == "wood"){
 				ent.getMetadata("nearby-resources-" + resource).forEach(function(ent){
-					Engine.PostCommand({"type": "set-shading-color", "entities": [ent.id()], "rgb": [0,10,0]});
+					Engine.PostCommand(PlayerID, {"type": "set-shading-color", "entities": [ent.id()], "rgb": [0,10,0]});
 				});
 			}
 			if (resource == "metal"){
 				ent.getMetadata("nearby-resources-" + resource).forEach(function(ent){
-					Engine.PostCommand({"type": "set-shading-color", "entities": [ent.id()], "rgb": [0,0,10]});
+					Engine.PostCommand(PlayerID, {"type": "set-shading-color", "entities": [ent.id()], "rgb": [0,0,10]});
 				});
 			}*/
 		});
Index: binaries/data/mods/public/simulation/ai/qbot/entitycollection-extend.js
===================================================================
--- binaries/data/mods/public/simulation/ai/qbot/entitycollection-extend.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/qbot/entitycollection-extend.js	(Arbeitskopie)
@@ -7,7 +7,7 @@
 		unitId = unit;
 	}
 	
-	Engine.PostCommand({"type": "attack", "entities": this.toIdArray(), "target": unitId, "queued": false});
+	Engine.PostCommand(PlayerID, {"type": "attack", "entities": this.toIdArray(), "target": unitId, "queued": false});
 	return this;
 };
 
@@ -37,4 +37,4 @@
 	}else{
 		return [sumPos[0]/count, sumPos[1]/count];
 	}
-};
\ Kein Zeilenumbruch am Ende der Datei
+};
Index: binaries/data/mods/public/simulation/ai/common-api-v2/entitycollection.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v2/entitycollection.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v2/entitycollection.js	(Arbeitskopie)
@@ -109,13 +109,13 @@
 EntityCollection.prototype.move = function(x, z, queued)
 {
 	queued = queued || false;
-	Engine.PostCommand({"type": "walk", "entities": this.toIdArray(), "x": x, "z": z, "queued": queued});
+	Engine.PostCommand(PlayerID, {"type": "walk", "entities": this.toIdArray(), "x": x, "z": z, "queued": queued});
 	return this;
 };
 
 EntityCollection.prototype.destroy = function()
 {
-	Engine.PostCommand({"type": "delete-entities", "entities": this.toIdArray()});
+	Engine.PostCommand(PlayerID, {"type": "delete-entities", "entities": this.toIdArray()});
 	return this;
 };
 
Index: binaries/data/mods/public/simulation/ai/common-api-v2/base.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v2/base.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v2/base.js	(Arbeitskopie)
@@ -1,3 +1,5 @@
+var PlayerID = -1;
+
 function BaseAI(settings)
 {
 	if (!settings)
@@ -112,8 +114,9 @@
 	return null;
 };
 
-BaseAI.prototype.HandleMessage = function(state)
+BaseAI.prototype.HandleMessage = function(state, playerID)
 {
+	PlayerID = playerID;
 	if (!this._entities)
 	{
 		// Do a (shallow) clone of all the initial entity properties (in order
@@ -237,7 +240,7 @@
 
 BaseAI.prototype.chat = function(message)
 {
-	Engine.PostCommand({"type": "chat", "message": message});
+	Engine.PostCommand(PlayerID, {"type": "chat", "message": message});
 };
 
 BaseAI.prototype.registerUpdatingEntityCollection = function(entCollection)
Index: binaries/data/mods/public/simulation/ai/common-api-v2/entity.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v2/entity.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v2/entity.js	(Arbeitskopie)
@@ -372,40 +372,40 @@
 
 	move: function(x, z, queued) {
 		queued = queued || false;
-		Engine.PostCommand({"type": "walk", "entities": [this.id()], "x": x, "z": z, "queued": queued});
+		Engine.PostCommand(PlayerID, {"type": "walk", "entities": [this.id()], "x": x, "z": z, "queued": queued});
 		return this;
 	},
 
 	garrison: function(target) {
-		Engine.PostCommand({"type": "garrison", "entities": [this.id()], "target": target.id(),"queued": false});
+		Engine.PostCommand(PlayerID, {"type": "garrison", "entities": [this.id()], "target": target.id(),"queued": false});
 		return this;
 	},
 
 	attack: function(unitId) {
-		Engine.PostCommand({"type": "attack", "entities": [this.id()], "target": unitId, "queued": false});
+		Engine.PostCommand(PlayerID, {"type": "attack", "entities": [this.id()], "target": unitId, "queued": false});
 		return this;
 	},
 
 	gather: function(target, queued) {
 		queued = queued || false;
-		Engine.PostCommand({"type": "gather", "entities": [this.id()], "target": target.id(), "queued": queued});
+		Engine.PostCommand(PlayerID, {"type": "gather", "entities": [this.id()], "target": target.id(), "queued": queued});
 		return this;
 	},
 
 	repair: function(target, queued) {
 		queued = queued || false;
-		Engine.PostCommand({"type": "repair", "entities": [this.id()], "target": target.id(), "autocontinue": false, "queued": queued});
+		Engine.PostCommand(PlayerID, {"type": "repair", "entities": [this.id()], "target": target.id(), "autocontinue": false, "queued": queued});
 		return this;
 	},
 	
 	returnResources: function(target, queued) {
 		queued = queued || false;
-		Engine.PostCommand({"type": "returnresource", "entities": [this.id()], "target": target.id(), "queued": queued});
+		Engine.PostCommand(PlayerID, {"type": "returnresource", "entities": [this.id()], "target": target.id(), "queued": queued});
 		return this;
 	},
 
 	destroy: function() {
-		Engine.PostCommand({"type": "delete-entities", "entities": [this.id()]});
+		Engine.PostCommand(PlayerID, {"type": "delete-entities", "entities": [this.id()]});
 		return this;
 	},
 
@@ -423,7 +423,7 @@
 			return this;
 		}
 
-		Engine.PostCommand({
+		Engine.PostCommand(PlayerID, {
 			"type": "train",
 			"entities": [this.id()],
 			"template": type,
@@ -437,7 +437,7 @@
 		// TODO: verify this unit can construct this, just for internal
 		// sanity-checking and error reporting
 
-		Engine.PostCommand({
+		Engine.PostCommand(PlayerID, {
 			"type": "construct",
 			"entities": [this.id()],
 			"template": template,
Index: binaries/data/mods/public/simulation/ai/common-api-v3/terrain-analysis-pathfinder.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v3/terrain-analysis-pathfinder.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v3/terrain-analysis-pathfinder.js	(Arbeitskopie)
@@ -1,3 +1,6 @@
+var API3 = function(m)
+{
+
 // An implementation of A* as a pathfinder.
 // It's oversamplable, and has a specific "distance from block"
 // variable to avoid narrow passages if wanted.
@@ -11,7 +14,7 @@
 
 // The initializer creates an expanded influence map for checking.
 // It's not extraordinarily slow, but it might be.
-function aStarPath(gameState, onWater, disregardEntities, targetTerritory) {
+m.aStarPath = function(gameState, onWater, disregardEntities, targetTerritory) {
 	var self = this;
 	
 	// get the terrain analyzer map as a reference.
@@ -52,10 +55,10 @@
 	}
 	this.expandInfluences(255,this.widthMap);
 }
-copyPrototype(aStarPath, Map);
+m.copyPrototype(m.aStarPath, m.Map);
 
 // marks some points of the map as impassable. This can be used to create different paths, or to avoid going through some areas.
-aStarPath.prototype.markImpassableArea = function(cx, cy, Distance) {
+m.aStarPath.prototype.markImpassableArea = function(cx, cy, Distance) {
 	[cx,cy] = this.gamePosToMapPos([cx,cy]);
 	var x0 = Math.max(0, cx - Distance);
 	var y0 = Math.max(0, cy - Distance);
@@ -78,7 +81,7 @@
 
 // sending gamestate creates a map
 // (you run the risk of "jumping" over obstacles or weird behavior.
-aStarPath.prototype.getPath = function(start, end, Sampling, preferredWidth, iterationLimit, gamestate)
+m.aStarPath.prototype.getPath = function(start, end, Sampling, preferredWidth, iterationLimit, gamestate)
 {
 	this.Sampling = Sampling >= 1 ? Sampling : 1;
 	this.minWidth = 1;
@@ -97,7 +100,7 @@
 	}
 	if (gamestate !== undefined)
 	{
-		this.TotorMap = new Map(gamestate);
+		this.TotorMap = new m.Map(gamestate);
 		this.TotorMap.addInfluence(s[0],s[1],1,200,'constant');
 		this.TotorMap.addInfluence(e[0],e[1],1,200,'constant');
 	}
@@ -135,7 +138,7 @@
 	
 	this.isOpened[this.s] = true;
 	this.openList.push(this.s);
-	this.fCostArray[this.s] = SquareVectorDistance([this.s%w, Math.floor(this.s/w)], [this.e%w, Math.floor(this.e/w)]);
+	this.fCostArray[this.s] = m.SquareVectorDistance([this.s%w, Math.floor(this.s/w)], [this.e%w, Math.floor(this.e/w)]);
 	this.gCostArray[this.s] = 0;
 	this.parentSquare[this.s] = this.s;
 	
@@ -143,7 +146,7 @@
 	
 }
 // in case it's not over yet, this can carry on the calculation of a path over multiple turn until it's over
-aStarPath.prototype.continuePath = function(gamestate)
+m.aStarPath.prototype.continuePath = function(gamestate)
 {
 	var w = this.width;
 	var h = this.height;
@@ -208,7 +211,7 @@
 				{
 					this.parentSquare[index] = this.currentSquare;
 					
-					this.fCostArray[index] = SquareVectorDistance([index%w, Math.floor(index/w)], target);// * cost[i];
+					this.fCostArray[index] = m.SquareVectorDistance([index%w, Math.floor(index/w)], target);// * cost[i];
 					this.gCostArray[index] = this.gCostArray[this.currentSquare] + cost[i] * this.Sampling;// - this.map[index];
 					
 					if (!this.onWater && this.map[index] === 200) {
@@ -231,7 +234,7 @@
 						this.openList.push(index);
 					}
 					this.isOpened[index] = true;
-					if (SquareVectorDistance( [index%w, Math.floor(index/w)] , target) <= this.Sampling*this.Sampling-1) {
+					if (m.SquareVectorDistance( [index%w, Math.floor(index/w)] , target) <= this.Sampling*this.Sampling-1) {
 						if (this.e != index)
 							this.parentSquare[this.e] = index;
 						found = true;
@@ -294,7 +297,7 @@
 			if (gamestate !== undefined)
 				this.TotorMap.addInfluence(this.currentSquare % w, Math.floor(this.currentSquare / w),1,50,'constant');
 			
-			if (SquareVectorDistance([lastPosx,lastPosy],[this.currentSquare % w, Math.floor(this.currentSquare / w)]) > 300 || changes[this.currentSquare])
+			if (m.SquareVectorDistance([lastPosx,lastPosy],[this.currentSquare % w, Math.floor(this.currentSquare / w)]) > 300 || changes[this.currentSquare])
 			{
 				lastPosx = (this.currentSquare % w);
 				lastPosy = Math.floor(this.currentSquare / w);
@@ -325,3 +328,7 @@
 	}
 	
 }
+
+return m;
+
+}(API3);
